function [ap testAUC tp fp] = evaluate(tssPos,tssNeg,mode)
% <mode> = 0 : the scores are individual feature scores
% <mode> = 1 : the scores are accumulated feature scores

if nargin < 3
    mode = 0;
end

maxNF = size(tssPos,2);
ap = zeros(maxNF,1);
testAUC = zeros(maxNF,1);
tp = cell(maxNF,1); fp = cell(maxNF,1);
for nF = 1:maxNF
    % Draw ROC curve and calculate AUC
    if mode == 0
        allScore = [sum(tssPos(:,1:nF),2);sum(tssNeg(:,1:nF),2)]; % scores of all test images
    else
        allScore = [sum(tssPos(:,nF),2);sum(tssNeg(:,nF),2)]; % scores of all test images
    end
    gt = [ones(size(tssPos,1),1);-1*ones(size(tssNeg,1),1)]; % ground truth of all test images
    [testAUC(nF) tp{nF}, fp{nF}] = calc_auc(allScore,gt); % obtain ROC curve by comparing predicted scores and ground truth
     % and true positive and false postive rate
    ap(nF) = getAP(gt,allScore);
end