% function analysisCrossValidation
clear

%% Plotting the average precision comparisons


% run 16~20: 80 positive training examples
count = 1; 
ap80 = zeros(1,5);
for iRun = 16:20
    load(sprintf('out_run%d.mat',iRun),'ap');
    ap80(count) = ap(end);
    count = count + 1;
end

% run 11~15: 40 positive training examples
count = 1; 
ap40 = zeros(1,5);
for iRun = 11:15
    load(sprintf('out_run%d.mat',iRun),'ap');
    ap40(count) = ap(end);
    count = count + 1;
end

% run 6~10: 20 positive training examples
count = 1; 
ap20 = zeros(1,5);
for iRun = 6:10
    load(sprintf('out_run%d.mat',iRun),'ap');
    ap20(count) = ap(end);
    count = count + 1;
end

% run 1~5: 10 positive training examples
count = 1;
ap10 = zeros(1,5);
for iRun = 1:5
    load(sprintf('out_run%d.mat',iRun),'ap');
    ap10(count) = ap(end);
    count = count + 1;
end

curve2 = [mean(ap10), mean(ap20), mean(ap40), mean(ap80)];
err2 = [std(ap10), std(ap20), std(ap40), std(ap80)];

h = figure; hold on;
plot([10,20,40,80],curve2+1*err2,'b--');
plot([10,20,40,80],curve2,'b--','LineWidth',3);
plot([10,20,40,80],curve2-1*err2,'b--');
ylim([0.55,1]);
legend('','active basis adapt','','Location','South');
title('Plotting average precision against number of positive training examples');


%% Plotting the AUC comparisons

% run 16~20: 80 positive training examples
count = 1; 
auc80 = zeros(1,5);
for iRun = 16:20
    load(sprintf('out_run%d.mat',iRun),'testAUC');
    auc80(count) = testAUC(end);
    count = count + 1;
end

% run 11~15: 40 positive training examples
count = 1; 
auc40 = zeros(1,5);
for iRun = 11:15
    load(sprintf('out_run%d.mat',iRun),'testAUC');
    auc40(count) = testAUC(end);
    count = count + 1;
end

% run 6~10: 20 positive training examples
count = 1; 
auc20 = zeros(1,5);
for iRun = 6:10
    load(sprintf('out_run%d.mat',iRun),'testAUC');
    auc20(count) = testAUC(end);
    count = count + 1;
end

% run 1~5: 10 positive training examples
count = 1; 
auc10 = zeros(1,5);
for iRun = 1:5
    load(sprintf('out_run%d.mat',iRun),'testAUC');
    auc10(count) = testAUC(end);
    count = count + 1;
end

curve2 = [mean(auc10), mean(auc20), mean(auc40), mean(auc80)];
err2 = [std(auc10), std(auc20), std(auc40), std(auc80)];

% Plot the three curves of Test AUC
%   with 68% confidence bounds
h = figure;
hold on;
plot([10,20,40,80],curve2+1*err2,'b--');
plot([10,20,40,80],curve2,'b--','LineWidth',3);
plot([10,20,40,80],curve2-1*err2,'b--');

ylim([0.75,1]);
legend({'','active basis adapt',''},'Location','SouthEast');
title('Plotting AUC against the number of positive training examples');

% Another plotting method: plot lines with error bars
% errorbar([10,20,40],curve1,err1,'LineWidth',3); hold on
% errorbar([10,20,40],curve2,err2,'+-r','LineWidth',3);
% errorbar([10,20,40],curve3,err3,'--k','LineWidth',3);

